



<!DOCTYPE html><html lang=zh-CN><head><meta http-equiv="Content-Type" content="text/html; charset=utf-8" /><meta http-equiv="X-UA-Compatible" content="IE=edge,chrome=1"><meta name="applicable-device" content="pc,mobile"><meta name="renderer" content="webkit"><meta name="viewport" content="width=device-width,initial-scale=1.0,maximum-scale=5,viewport-fit=cover">
<title>【 D3.js 入门系列 --- 5 】 如何添加坐标轴</title>	
<script src="//n4.ikafan.com/assets/run_prettify.js?ac"></script>
<link rel="stylesheet" href="//n4.ikafan.com/assetsg/style.css">
<!-- <link rel="stylesheet" href="//pic.ikafan.com/staticx/shuzhiduo/1/css.grace/fontello.css?ac"> -->
<!-- <link rel="stylesheet" href="//pic.ikafan.com/staticx/shuzhiduo/1/css.grace/animation.css?ac"> -->
<script>
var _hmt = _hmt || [];
(function() {
  var hm = document.createElement("script");
  hm.src = "https://hm.baidu.com/hm.js?c61d51e9fdcf1d1631ddfce8df9cd119";
  var s = document.getElementsByTagName("script")[0]; 
  s.parentNode.insertBefore(hm, s);
})();
</script>
<script src="https://n4.ikafan.com/g/show.js"></script>

</head>
<div id="header" class="navbar navbar-default navbar-fixed-top header-01">
	<div class="container">
		<h1 class="logo">
			<a  href="/" title="巴特西"/>
							巴特西
			</a>
		</h1>
				<div role="navigation"  class="site-nav  primary-menu">
			<div class="menu-fix-box">
				 <ul id="menu-navigation" class="menu" >
<li><a href="/">首页</a></li>
<!-- <li><a href="/search/Hadoop/">Hadoop</a></li>
<li><a href="/search/Linux/">Linux</a></li>
<li><a href="/search/jQuery/">jQuery</a></li> -->
<li><a href="/search/Python/">Python</a></li>
<li><a href="/search/Java/">Java</a></li>
<li><a href="/search/PHP/">PHP</a></li>
<li><a href="/search/IOS/">IOS</a></li>
<li><a href="/search/Andorid/">Andorid</a></li>
<li><a href="/search/NodeJS/">NodeJS</a></li>
<li><a href="/search/JavaScript/">JavaScript</a></li>
<li><a href="/search/HTML5/">HTML5</a></li>
				</ul>					 			
			</div>
		</div>
				<!--<div class="right-nav">
				<button class="js-toggle-search"><i class="icon-search"></i></button>
		</div>-->
       
			</div>	
</div>

<div id="page-content">
	<div class="container">
		<div class="row">
			
			<div class="blog-post">
								<!--<div class="posts-top-cjtz clearfix"></div>-->
								<div class="post">
										<div class="post-title">
											<div id="title_top"></div>
<script>insertAdIfNeeded();</script>
						<h1 class="title">【 D3.js 入门系列 --- 5 】 如何添加坐标轴</h1>
						<div class="post_icon">
							<span class="icon-clock-1"> 2024-03-19 12:27:00 </span>
						</div>
										<div class="post-content">
													<div id="single_top"></div>
<script>insertAdIfNeeded();</script>
											
		<p>第3节中做了一个图标，但没有为它添加一个相应的坐标轴，这样不知道每一个柱形到底有多长。这一节做一个坐标轴。</p>
<p>D3中的坐标轴都是以 svg 图的形式出现的，这也是为什么在第3节中要使用 svg 的方法做柱形图的原因。第4节里我们讲解了 scale （比例）的用法，在做坐标轴的时候也需要用到比例。第4节中，我们说到scale 是一个函数，这一节中的坐标轴也是一个函数，但是用法却有点不同，要注意。</p>
<p>看下面的代码，我们分别定义数据，scale （比例），坐标轴：</p>
<div>
<ol><li>var&nbsp;dataset&nbsp;=&nbsp;[&nbsp;30&nbsp;,&nbsp;20&nbsp;,&nbsp;45&nbsp;,&nbsp;12&nbsp;,&nbsp;21&nbsp;];</li>
<li>var&nbsp;xScale&nbsp;=&nbsp;d3.scale.linear()</li>
<li>.domain([0,d3.max(dataset)])</li>
<li>.range([0,500]);</li>
<li>var&nbsp;axis&nbsp;=&nbsp;d3.svg.axis()</li>
<li>.scale(xScale)</li>
<li>.orient("bottom");</li></ol>
</div>
<p>1-4行是定义数据和 scale （比例），关于比例的内容可看上一节。</p>
<p>5-7是定义坐标轴：</p>
<ul><li>d3.svg.axis() 调用这个函数就会生成一个坐标轴的函数</li>
<li>scale() 这个函数用于指定坐标轴的 scale （比例）</li>
<li>orient() 这个函数用于指定坐标轴的分割点和数字的朝向，在哪个方向显示。 bottom 表示在坐标轴的下方显示。</li></ul>
<div>&nbsp; &nbsp; 画出坐标轴的代码如下：</div>
<div>
<div>
<ol><li>svg.append("g")</li>
<li>.call(axis);</li></ol>
</div>
<p>在 svg 中添加一个g，g是 svg 中的一个属性，是 group 的意思，它表示一组什么东西，如一组 lines ， rects ，circles 其实坐标轴就是由这些东西构成的。</p></div>
<div>&nbsp; &nbsp; 上面还调用了一个&nbsp;call 函数，这个比较重要。在 D3 中，call 相当于定义一个函数，再把选择的元素给它，即相当于如下代码：</div>
<div>
<div>
<ol><li>function&nbsp;foo(selection)&nbsp;{</li>
<li>selection</li>
<li>.attr("name1",&nbsp;"value1")</li>
<li>.attr("name2",&nbsp;"value2");</li>
<li>}</li>
<li>foo(d3.selectAll("div"))</li></ol>
</div>
<p>这段代码等同于：</p></div>
<div>
<div>
<ol><li>d3.selectAll("div").call(foo);</li></ol>
</div>
<p>所以 svg.append("g").call(axis) 就相当于将选择的g元素传给 axis 函数。</p></div>
<div>&nbsp; &nbsp; 调用之后，坐标轴就会显示在相应的 svg 中。<br />&nbsp; &nbsp; 还可以定义几个css样式改变坐标轴的粗细，字体等等。 transform 属性用于移动坐标轴在 svg 中的位置。</div>
<div>
<div>
<ol><li>svg.append("g")</li>
<li>.attr("class","axis")</li>
<li>.attr("transform","translate(10,160)")</li>
<li>.call(axis);</li></ol>
</div>
</div>
<div>&nbsp; &nbsp; 完整的代码如下：</div>
<div>
<div>
<ol><li>&lt;style&gt;</li>
<li>.axis&nbsp;path,</li>
<li>.axis&nbsp;line{</li>
<li>fill:&nbsp;none;</li>
<li>stroke:&nbsp;black;</li>
<li>shape-rendering:&nbsp;crispEdges;</li>
<li>}</li>
<li>.axis&nbsp;text&nbsp;{</li>
<li>font-family:&nbsp;sans-serif;</li>
<li>font-size:&nbsp;11px;</li>
<li>}</li>
<li>&lt;/style&gt;</li>
<li>&lt;body&gt;</li>
<li>&lt;script&nbsp;src="http://d3js.org/d3.v3.min.js"&nbsp;charset="utf-8"&gt;&lt;/script&gt;</li>
<li>&lt;script&gt;</li>
<li>var&nbsp;width&nbsp;=&nbsp;600;</li>
<li>var&nbsp;height&nbsp;=&nbsp;600;</li>
<li>var&nbsp;dataset&nbsp;=&nbsp;[&nbsp;30&nbsp;,&nbsp;20&nbsp;,&nbsp;45&nbsp;,&nbsp;12&nbsp;,&nbsp;21&nbsp;];</li>
<li>var&nbsp;svg&nbsp;=&nbsp;d3.select("body").append("svg")</li>
<li>.attr("width",width)</li>
<li>.attr("height",height);</li>
<li>var&nbsp;xScale&nbsp;=&nbsp;d3.scale.linear()</li>
<li>.domain([0,d3.max(dataset)])</li>
<li>.range([0,500]);</li>
<li>var&nbsp;axis&nbsp;=&nbsp;d3.svg.axis()</li>
<li>.scale(xScale)</li>
<li>.orient("bottom");</li>
<li>svg.append("g")</li>
<li>.attr("class","axis")</li>
<li>.attr("transform","translate(10,160)")</li>
<li>.call(axis);</li>
<li>svg.selectAll("rect")</li>
<li>.data(dataset)</li>
<li>.enter()</li>
<li>.append("rect")</li>
<li>.attr("x",10)</li>
<li>.attr("y",function(d,i){</li>
<li>return&nbsp;i&nbsp;*&nbsp;30;</li>
<li>})</li>
<li>.attr("width",xScale)&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;//注意这里</li>
<li>.attr("height",28)</li>
<li>.attr("fill","red");</li>
<li>&lt;/script&gt;</li></ol>
</div>
<p>结果如下图：</div>
<div><img referrerpolicy="no-referrer"src="http://img.my.csdn.net/uploads/201406/24/1403576391_1820.png" /></div>
<div>&nbsp;</div>
<div>&nbsp; &nbsp;&nbsp;</div>
<div>&nbsp;</div>
<div>&nbsp;</div>
<div>&nbsp;</div>
<div>&nbsp;</div>
<div>&nbsp;</div>
<div>&nbsp;</div>
<div>&nbsp;</div>
<div>
<p>博客为：&nbsp;<a href="http://www.ourd3js.com/" rel="external nofollow noreferrer">www.ourd3js.com</a>&nbsp; &nbsp; &nbsp;&nbsp;csdn博客为：&nbsp;<a href="http://blog.csdn.net/lzhlzz/" rel="external nofollow noreferrer">blog.csdn.net/lzhlzz</a></p>
</div>												<div id="single_bottom"></div>
<script>insertAdIfNeeded();</script>
																
<h2>最新文章</h2>	
<ol>
						<li><a href="https://www.batexi.com/a/o8kre37q.html">如何实现桌面App图标可以动态显示消息数&lpar;类似手机上的QQ图标&rpar;&quest;</a>
		</li>
						<li><a href="https://www.batexi.com/a/o8kz0rj8.html">zabbix3&period;2&period;0beta2 监控模版</a>
		</li>
						<li><a href="https://www.batexi.com/a/495omee8.html">c&num;之第一课入门</a>
		</li>
						<li><a href="https://www.batexi.com/a/2q7krjk9.html">kafka常用的操作命令</a>
		</li>
						<li><a href="https://www.batexi.com/a/m8z5non8.html">NSUserDefaults的小封装</a>
		</li>
						<li><a href="https://www.batexi.com/a/8k1jlr39.html">使用k-近邻算法改进约会网站的配对效果</a>
		</li>
						<li><a href="https://www.batexi.com/a/q1zp5p09.html">PHP如何返回json格式的数据</a>
		</li>
						<li><a href="https://www.batexi.com/a/8k12zm39.html">Java计算日期和时间差</a>
		</li>
						<li><a href="https://www.batexi.com/a/qdeg7zv9.html">EXTJS 3&period;0 资料 控件之 FormPanel 插入button用法</a>
		</li>
						<li><a href="https://www.batexi.com/a/qwdzzor8.html">TD&lpar;TestDirector 8&period;0&rpar;在win7 ie8下无法用的解决方案：</a>
		</li>
						<li><a href="https://www.batexi.com/a/qde3roj9.html">腾讯面试题 腾讯面试题：给40亿个不重复的unsigned int的整数，没排过序的，然后再给一个数，如何快速判断这个数是否在那40亿个数当中？</a>
		</li>
						<li><a href="https://www.batexi.com/a/8k1zx379.html">Java jdk环境搭建</a>
		</li>
						<li><a href="https://www.batexi.com/a/q4yr5nnq.html">登陆权限验证Session和Cookie用法及BasePage类使用</a>
		</li>
						<li><a href="https://www.batexi.com/a/95x4erv8.html">容器vector的使用总结  容器stack&lpar;栈&rpar;</a>
		</li>
						<li><a href="https://www.batexi.com/a/9pdngld9.html">uva - The Lottery&lpar;容斥，好题&rpar;</a>
		</li>
						<li><a href="https://www.batexi.com/a/8kpjyyj9.html">MapXtreme&plus;Asp&period;net 动态轨迹</a>
		</li>
						<li><a href="https://www.batexi.com/a/q7zezog9.html">GMap学习笔记</a>
		</li>
						<li><a href="https://www.batexi.com/a/9ge0j2z8.html">EntityFrameWork连接多Db配置</a>
		</li>
						<li><a href="https://www.batexi.com/a/9jz45re8.html">java客户端调用webService</a>
		</li>
						<li><a href="https://www.batexi.com/a/qdpn5wxq.html">Unity资源 ----加载最好需要做哪些事</a>
		</li>
		</ol>
	

<h2>热门文章</h2>	
<ol>
									<li><a href="https://www.batexi.com/a/r932orgq.html">Rails&comma;uva 514</a>
			</li>
						<li><a href="https://www.batexi.com/a/5qxmdv09.html">4s前置摄像头调用</a>
			</li>
						<li><a href="https://www.batexi.com/a/r932pknq.html">【转】Image Cyborg 一键下载存储网页所有图片</a>
			</li>
						<li><a href="https://www.batexi.com/a/0qwm5ml8.html">css知识点积累</a>
			</li>
						<li><a href="https://www.batexi.com/a/m8znrmn8.html">CTSC2015 酱油记</a>
			</li>
						<li><a href="https://www.batexi.com/a/r932nxrq.html">&lbrack;转载&rsqb;MySQL将DateTime时间类型格式化</a>
			</li>
						<li><a href="https://www.batexi.com/a/495kjdm9.html">PLSQL开发笔记和小结&lpar;转载&rpar;</a>
			</li>
						<li><a href="https://www.batexi.com/a/jqd4zxvq.html">转&colon; jdbc连接数据库需要注意和出错的地方</a>
			</li>
						<li><a href="https://www.batexi.com/a/e9j4vee9.html">find&lowbar;first&lowbar;of&lpar;&rpar;和 find&lowbar;last&lowbar;of&lpar;&rpar; 【获取路径、文件名】</a>
			</li>
						<li><a href="https://www.batexi.com/a/5qxm63j9.html">JSON序列化和反序列化的实例</a>
			</li>
			</ol>			
							
					</div>

					
<div class="next-prev-posts clearfix">
</div>
						 
				</div>
				
	<div class="clear"></div>

			</div>	
			

		</div>
</div>
</div>


<div class="clearfix"></div>
<div id="footer" class="two-s-footer">
	<div class="footer-box">
		<div class="container">
			<div class="row" style="padding-left: 15px;padding-right: 15px;">
			<div class="nav-footer">
				<a href="/">Home</a>
				</div>
				<div class="copyright-footer">
					<p>Powered By WordPress</p>
				</div>
							</div>
		</div>
	</div>
</div>
<div style="display:none">

</div>
<script src="//n4.ikafan.com/assets/js/echo.js"></script>
<script>
    echo.init({
      offset: 100,
      throttle: 250,
      unload: false,
      callback: function (element, op) {
        console.log(element, 'has been', op + 'ed')
      }
    });
 </script>
</body>
</html>
